"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Base64_1 = require("../models/Base64");
const crypto_1 = require("../crypto");
const ecies = __importStar(require("../crypto/ecies"));
const Uncrumb_1 = require("./Uncrumb");
exports.decrypt = (c, s) => __awaiter(void 0, void 0, void 0, function* () {
    let decrypted = '';
    if (s.privateKey !== null && s.privateKey !== undefined) {
        switch (s.encryptionAlgorithm) {
            case crypto_1.ECIES_ALGORITHM: {
                // IMPORTANT: the signer's private key hexadecimal string has to be passed through the `ecies.getPrivateKeyBuffer()` function beforehand
                const deciphered = yield ecies.decrypt(c.encrypted.toBytes(), s.privateKey);
                decrypted = deciphered.toString('base64');
                break;
            }
            default:
                throw new Error('unknown encryption algorithm: ' + s.encryptionAlgorithm);
        }
    }
    return new Uncrumb_1.Uncrumb(new Base64_1.Base64(decrypted), c.index);
});
__export(require("./Collector"));
__export(require("./Uncrumb"));
