"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Base64_1 = require("../models/Base64");
class Crumb {
    constructor(encrypted, index, length) {
        this.encrypted = encrypted;
        this.index = index;
        this.length = length;
    }
    equals(otherCrumb) {
        if (this.encrypted.toString() === otherCrumb.encrypted.toString() &&
            this.index === otherCrumb.index &&
            this.length === otherCrumb.length) {
            return true;
        }
        return false;
    }
    toString() {
        return this.index.toString(16).padStart(2, '0') + this.length.toString(16).padStart(4, '0') + this.encrypted.toString();
    }
}
exports.Crumb = Crumb;
exports.toCrumb = (unparsed) => {
    const parsed = exports.parseCrumb(unparsed);
    const c = new Crumb(new Base64_1.Base64(parsed[2]), parsed[0], parsed[1]);
    return c;
};
exports.parseCrumb = (unparsed) => {
    const idxHex = unparsed.substr(0, 2);
    const idx = parseInt(idxHex, 16);
    const lnHex = unparsed.substr(2, 4);
    const ln = parseInt(lnHex, 16);
    const enc = unparsed.substr(6);
    if (!Base64_1.isBase64String(enc)) {
        throw new Error('not a base64-encoded string: ' + enc);
    }
    if (ln !== enc.length) {
        throw new Error('incompatible lengths');
    }
    return [idx, ln, enc];
};
