export declare const PREPEND_SIZE = 2;
export declare const ALTERNATE_PADDING_CHARACTER_1 = "\u0004";
export declare const ALTERNATE_PADDING_CHARACTER_2 = "\u0005";
export declare class Padder {
    /**
     * Left pads the passed data (generally a slice) making it at least (PREPEND_SIZE + length) bytes long,
     * except if the 'buildEven' parameter is set to `true`. In that case, it doesn't take PREPEND_SIZE into account
     * and only adds padding bytes to the left up to the passed length to make it odd long.
     *
     * @param {string} slice - the data to obfuscate
     * @returns the byte array of the obfuscated result
     */
    apply(slice: string, length: number, buildEven?: boolean): string;
    /**
     * Unpad the passed data
     *
     * @param {string} padded - the padded string to use
     * @returns the unpadded string
     */
    unapply(padded: string): string;
}
//# sourceMappingURL=index.d.ts.map