/// <reference types="node" />
import { Crumb } from '../Encrypter/Crumb';
import { Signer } from '../models/Signer';
import { Uncrumb } from '../Decrypter/Uncrumb';
export declare class Uncrumbl {
    crumbled: string;
    slices: Array<Uncrumb>;
    verificationHash: string;
    signer: Signer;
    isOwner: boolean;
    private cipher;
    constructor(crumbled: string, slices: Array<Uncrumb>, verificationHash: string, signer: Signer, isOwner: boolean);
    process(): Promise<Buffer>;
    toHTML(element: HTMLElement): Promise<Buffer>;
    private doUncrumbl;
}
/**
 * Extract the verification hash and the crumbs from the passed crumbled string
 *
 * @param {string} crumbl - The full crumbled string
 * @returns the verification hash and the array of crumbs
 */
export declare const extractData: (crumbled: string) => [string, Crumb[]];
/**
 * Extract the hashered prefix from the passed crumbled string
 *
 * @param {string} crumbl - The full crumbled string
 * @returns the hashered prefix
 */
export declare const getHasheredSrc: (crumbled: string) => string;
//# sourceMappingURL=Uncrumbl.d.ts.map