/// <reference types="node" />
/**
 * Eventually returns the ECIES-encrypted buffer of the passed message
 *
 * @param msg the message to encrypt
 * @param publicKey the ecies public key
 */
export declare const encrypt: (msg: Buffer, publicKey: Buffer) => Promise<Buffer>;
/**
 * Eventually returns the ECIES-decrypted buffer of the passed ciphertext
 *
 * @param ciphered the ciphertext to decrypt
 * @param privateKey the ecies private key
 */
export declare const decrypt: (ciphered: Buffer, privateKey: Buffer) => Promise<Buffer>;
//# sourceMappingURL=index.d.ts.map