"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ecies = __importStar(require("ecies-geth"));
/**
 * Eventually returns the ECIES-encrypted buffer of the passed message
 *
 * @param msg the message to encrypt
 * @param publicKey the ecies public key
 */
exports.encrypt = (msg, publicKey) => {
    return ecies.encrypt(publicKey, msg);
};
/**
 * Eventually returns the ECIES-decrypted buffer of the passed ciphertext
 *
 * @param ciphered the ciphertext to decrypt
 * @param privateKey the ecies private key
 */
exports.decrypt = (ciphered, privateKey) => {
    return ecies.decrypt(privateKey, ciphered);
};
